diff --git a/ArmVirtPkg/Library/PlatformIntelBdsLib/PlatformIntelBdsLib.inf b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBootManagerLib.inf
similarity index 87%
copy from ArmVirtPkg/Library/PlatformIntelBdsLib/PlatformIntelBdsLib.inf
copy to ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBootManagerLib.inf
index f104accc0334..1ad4c6f220f8 100644
--- a/ArmVirtPkg/Library/PlatformIntelBdsLib/PlatformIntelBdsLib.inf
+++ b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBootManagerLib.inf
@@ -1,7 +1,7 @@
 ## @file
-#  Implementation for PlatformBdsLib library class interfaces.
+#  Implementation for PlatformBootManagerLib library class interfaces.
 #
-#  Copyright (C) 2015, Red Hat, Inc.
+#  Copyright (C) 2015-2016, Red Hat, Inc.
 #  Copyright (c) 2014, ARM Ltd. All rights reserved.<BR>
 #  Copyright (c) 2007 - 2014, Intel Corporation. All rights reserved.<BR>
 #
@@ -19,7 +19,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = PlatformIntelBdsLib
-  FILE_GUID                      = 46DF84EB-F603-4D39-99D8-E1E86B50BCC2
+  FILE_GUID                      = 469184E8-FADA-41E4-8823-012CA19B40D4
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = PlatformBdsLib|DXE_DRIVER
@@ -31,7 +31,7 @@ [Defines]
 #
 
 [Sources]
-  IntelBdsPlatform.c
+  PlatformBm.c
   QemuKernel.c
 
 [Packages]
diff --git a/ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.h b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.h
similarity index 90%
copy from ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.h
copy to ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.h
index 190ce9b294b0..410c309cfcbf 100644
--- a/ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.h
+++ b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.h
@@ -1,6 +1,7 @@
 /** @file
   Head file for BDS Platform specific code
 
+  Copyright (C) 2015-2016, Red Hat, Inc.
   Copyright (c) 2004 - 2008, Intel Corporation. All rights reserved.<BR>
 
   This program and the accompanying materials are licensed and made available
@@ -13,8 +14,8 @@
 
 **/
 
-#ifndef _INTEL_BDS_PLATFORM_H_
-#define _INTEL_BDS_PLATFORM_H_
+#ifndef _PLATFORM_BM_H_
+#define _PLATFORM_BM_H_
 
 #include <Library/BaseLib.h>
 #include <Library/BaseMemoryLib.h>
@@ -53,4 +54,4 @@ TryRunningQemuKernel (
   VOID
   );
 
-#endif // _INTEL_BDS_PLATFORM_H
+#endif // _PLATFORM_BM_H_
diff --git a/ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.c b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.c
similarity index 95%
copy from ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.c
copy to ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.c
index 02d698b455b3..f841d7c1b5c6 100644
--- a/ArmVirtPkg/Library/PlatformIntelBdsLib/IntelBdsPlatform.c
+++ b/ArmVirtPkg/Library/PlatformBootManagerLib/PlatformBm.c
@@ -1,7 +1,7 @@
 /** @file
-  Implementation for PlatformBdsLib library class interfaces.
+  Implementation for PlatformBootManagerLib library class interfaces.
 
-  Copyright (C) 2015, Red Hat, Inc.
+  Copyright (C) 2015-2016, Red Hat, Inc.
   Copyright (c) 2014, ARM Ltd. All rights reserved.<BR>
   Copyright (c) 2004 - 2008, Intel Corporation. All rights reserved.<BR>
 
@@ -27,7 +27,7 @@
 #include <Guid/EventGroup.h>
 #include <Guid/RootBridgesConnectedEventGroup.h>
 
-#include "IntelBdsPlatform.h"
+#include "PlatformBm.h"
 
 #define DP_NODE_LEN(Type) { (UINT8)sizeof (Type), (UINT8)(sizeof (Type) >> 8) }
 
diff --git a/ArmVirtPkg/Library/PlatformIntelBdsLib/QemuKernel.c b/ArmVirtPkg/Library/PlatformBootManagerLib/QemuKernel.c
similarity index 96%
copy from ArmVirtPkg/Library/PlatformIntelBdsLib/QemuKernel.c
copy to ArmVirtPkg/Library/PlatformBootManagerLib/QemuKernel.c
index 402db97a80a7..ac47d21e71c8 100644
--- a/ArmVirtPkg/Library/PlatformIntelBdsLib/QemuKernel.c
+++ b/ArmVirtPkg/Library/PlatformBootManagerLib/QemuKernel.c
@@ -4,7 +4,7 @@
   This implementation differs from OvmfPkg/Library/LoadLinuxLib. An EFI
   stub in the subject kernel is a hard requirement here.
 
-  Copyright (C) 2014, Red Hat, Inc.
+  Copyright (C) 2014-2016, Red Hat, Inc.
 
   This program and the accompanying materials are licensed and made available
   under the terms and conditions of the BSD License which accompanies this
@@ -24,7 +24,7 @@
 #include <Protocol/LoadedImage.h>
 #include <Protocol/SimpleFileSystem.h>
 
-#include "IntelBdsPlatform.h"
+#include "PlatformBm.h"
 
 //
 // Static data that hosts the fw_cfg blobs and serves file requests.